package wordcount;

import java.util.Map;

import org.apache.storm.Config;
import org.apache.storm.LocalCluster;
import org.apache.storm.StormSubmitter;
import org.apache.storm.generated.AlreadyAliveException;
import org.apache.storm.generated.AuthorizationException;
import org.apache.storm.generated.InvalidTopologyException;
import org.apache.storm.task.ShellBolt;
import org.apache.storm.topology.BasicOutputCollector;
import org.apache.storm.topology.IRichBolt;
import org.apache.storm.topology.OutputFieldsDeclarer;
import org.apache.storm.topology.TopologyBuilder;
import org.apache.storm.topology.base.BaseBasicBolt;
import org.apache.storm.tuple.Fields;
import org.apache.storm.tuple.Tuple;
import org.apache.storm.tuple.Values;

public class WordCountTopology {
	public static void main(String[] args) throws AlreadyAliveException, InvalidTopologyException, AuthorizationException, InterruptedException {
		
		//׼һTopologyBuilder
		TopologyBuilder builder=new TopologyBuilder();
		builder.setSpout("spout",new RandomSentenceSpout(),Integer.valueOf(5));
		builder.setBolt("split",new SplitSentenceBolt(),Integer.valueOf(8)).shuffleGrouping("spout");
		//ΪʲôfieldGroupingз飬ΪҪͬһֶͬʱһtaskУܹͳ
		builder.setBolt("count",new WordCountBolt(),Integer.valueOf(12)).fieldsGrouping("split",new Fields(new String[] {"word"}));
		
		//һconfigurationƶǰtopologyҪ
		Config conf=new Config();
		conf.setNumWorkers(2);
		//conf.setDebug(true);
		
		//ύ
		//stormģʽ
		//ȺģʽڼȺ
		//ģʽǰ༭
		StormSubmitter.submitTopology("word-count",conf,builder.createTopology());
		/*
			conf.setMaxTaskParallelism(3);
			LocalCluster cluster=new LocalCluster();
			cluster.submitTopology("word-count",conf,builder.createTopology());
			Thread.sleep(10000L);
			cluster.shutdown();
			*/
	}
}